]>
Commit | Line | Data |
---|---|---|
f2c66ed1 NS |
1 | #!/bin/sh |
2 | # Copyright (c) 2007, Nanako Shiraishi | |
3 | ||
a5ab00c5 SB |
4 | dashless=$(basename "$0" | sed -e 's/-/ /') |
5 | USAGE="list [<options>] | |
fcdd0e92 SB |
6 | or: $dashless show [<stash>] |
7 | or: $dashless drop [-q|--quiet] [<stash>] | |
8 | or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>] | |
a5ab00c5 | 9 | or: $dashless branch <branchname> [<stash>] |
1ada5020 TG |
10 | or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet] |
11 | [-u|--include-untracked] [-a|--all] [<message>] | |
12 | or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet] | |
13 | [-u|--include-untracked] [-a|--all] [-m <message>] | |
14 | [-- <pathspec>...]] | |
a5ab00c5 | 15 | or: $dashless clear" |
f2c66ed1 | 16 | |
3cd2491a | 17 | SUBDIRECTORY_OK=Yes |
8f321a39 | 18 | OPTIONS_SPEC= |
d0ea45bf | 19 | START_DIR=$(pwd) |
f2c66ed1 NS |
20 | . git-sh-setup |
21 | require_work_tree | |
22fc703e | 22 | prefix=$(git rev-parse --show-prefix) || exit 1 |
ceff079b | 23 | cd_to_toplevel |
f2c66ed1 NS |
24 | |
25 | TMP="$GIT_DIR/.git-stash.$$" | |
c697b577 | 26 | TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$ |
3ba2e865 | 27 | trap 'rm -f "$TMP-"* "$TMPindex"' 0 |
f2c66ed1 NS |
28 | |
29 | ref_stash=refs/stash | |
30 | ||
dda1f2a5 TR |
31 | if git config --get-colorbool color.interactive; then |
32 | help_color="$(git config --get-color color.interactive.help 'red bold')" | |
33 | reset_color="$(git config --get-color '' reset)" | |
34 | else | |
35 | help_color= | |
36 | reset_color= | |
37 | fi | |
38 | ||
f2c66ed1 | 39 | no_changes () { |
df6bba09 TG |
40 | git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" && |
41 | git diff-files --quiet --ignore-submodules -- "$@" && | |
d319bb18 | 42 | (test -z "$untracked" || test -z "$(untracked_files "$@")") |
78751302 DC |
43 | } |
44 | ||
45 | untracked_files () { | |
5fc92f88 KD |
46 | if test "$1" = "-z" |
47 | then | |
48 | shift | |
49 | z=-z | |
50 | else | |
51 | z= | |
52 | fi | |
78751302 DC |
53 | excl_opt=--exclude-standard |
54 | test "$untracked" = "all" && excl_opt= | |
5fc92f88 | 55 | git ls-files -o $z $excl_opt -- "$@" |
f2c66ed1 NS |
56 | } |
57 | ||
58 | clear_stash () { | |
3023dc69 JH |
59 | if test $# != 0 |
60 | then | |
b1440ce2 | 61 | die "$(gettext "git stash clear with parameters is unimplemented")" |
3023dc69 | 62 | fi |
1956dfa8 | 63 | if current=$(git rev-parse --verify --quiet $ref_stash) |
7ab3cc70 | 64 | then |
a9ee9bf9 | 65 | git update-ref -d $ref_stash $current |
7ab3cc70 | 66 | fi |
f2c66ed1 NS |
67 | } |
68 | ||
bc9e7399 | 69 | create_stash () { |
9ca6326d TG |
70 | stash_msg= |
71 | untracked= | |
72 | while test $# != 0 | |
73 | do | |
74 | case "$1" in | |
75 | -m|--message) | |
76 | shift | |
77 | stash_msg=${1?"BUG: create_stash () -m requires an argument"} | |
78 | ;; | |
5675473f PH |
79 | -m*) |
80 | stash_msg=${1#-m} | |
81 | ;; | |
82 | --message=*) | |
83 | stash_msg=${1#--message=} | |
84 | ;; | |
9ca6326d TG |
85 | -u|--include-untracked) |
86 | shift | |
87 | untracked=${1?"BUG: create_stash () -u requires an argument"} | |
88 | ;; | |
df6bba09 TG |
89 | --) |
90 | shift | |
91 | break | |
92 | ;; | |
9ca6326d TG |
93 | esac |
94 | shift | |
95 | done | |
9f62e18a | 96 | |
1eff26c0 | 97 | git update-index -q --refresh |
df6bba09 | 98 | if no_changes "$@" |
f2c66ed1 | 99 | then |
f2c66ed1 NS |
100 | exit 0 |
101 | fi | |
f12e925a | 102 | |
f2c66ed1 | 103 | # state of the base commit |
5be60078 | 104 | if b_commit=$(git rev-parse --verify HEAD) |
f2c66ed1 | 105 | then |
b0e621ad | 106 | head=$(git rev-list --oneline -n 1 HEAD --) |
f2c66ed1 | 107 | else |
b1440ce2 | 108 | die "$(gettext "You do not have the initial commit yet")" |
f2c66ed1 NS |
109 | fi |
110 | ||
5be60078 | 111 | if branch=$(git symbolic-ref -q HEAD) |
f2c66ed1 NS |
112 | then |
113 | branch=${branch#refs/heads/} | |
114 | else | |
115 | branch='(no branch)' | |
116 | fi | |
117 | msg=$(printf '%s: %s' "$branch" "$head") | |
118 | ||
119 | # state of the index | |
5be60078 | 120 | i_tree=$(git write-tree) && |
6143fa2c | 121 | i_commit=$(printf 'index on %s\n' "$msg" | |
5be60078 | 122 | git commit-tree $i_tree -p $b_commit) || |
b1440ce2 | 123 | die "$(gettext "Cannot save the current index state")" |
f2c66ed1 | 124 | |
78751302 DC |
125 | if test -n "$untracked" |
126 | then | |
127 | # Untracked files are stored by themselves in a parentless commit, for | |
128 | # ease of unpacking later. | |
129 | u_commit=$( | |
5fc92f88 | 130 | untracked_files -z "$@" | ( |
bed137d2 EP |
131 | GIT_INDEX_FILE="$TMPindex" && |
132 | export GIT_INDEX_FILE && | |
78751302 DC |
133 | rm -f "$TMPindex" && |
134 | git update-index -z --add --remove --stdin && | |
135 | u_tree=$(git write-tree) && | |
136 | printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree && | |
137 | rm -f "$TMPindex" | |
850251f3 | 138 | ) ) || die "$(gettext "Cannot save the untracked files")" |
78751302 DC |
139 | |
140 | untracked_commit_option="-p $u_commit"; | |
141 | else | |
142 | untracked_commit_option= | |
143 | fi | |
144 | ||
dda1f2a5 TR |
145 | if test -z "$patch_mode" |
146 | then | |
147 | ||
148 | # state of the working tree | |
149 | w_tree=$( ( | |
3ba2e865 JS |
150 | git read-tree --index-output="$TMPindex" -m $i_tree && |
151 | GIT_INDEX_FILE="$TMPindex" && | |
dda1f2a5 | 152 | export GIT_INDEX_FILE && |
df6bba09 | 153 | git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" && |
44df2e29 | 154 | git update-index -z --add --remove --stdin <"$TMP-stagenames" && |
dda1f2a5 | 155 | git write-tree && |
3ba2e865 | 156 | rm -f "$TMPindex" |
dda1f2a5 | 157 | ) ) || |
b1440ce2 | 158 | die "$(gettext "Cannot save the current worktree state")" |
dda1f2a5 TR |
159 | |
160 | else | |
161 | ||
b24f56d6 | 162 | rm -f "$TMP-index" && |
dda1f2a5 TR |
163 | GIT_INDEX_FILE="$TMP-index" git read-tree HEAD && |
164 | ||
165 | # find out what the user wants | |
166 | GIT_INDEX_FILE="$TMP-index" \ | |
df6bba09 | 167 | git add--interactive --patch=stash -- "$@" && |
dda1f2a5 TR |
168 | |
169 | # state of the working tree | |
170 | w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) || | |
b1440ce2 | 171 | die "$(gettext "Cannot save the current worktree state")" |
f2c66ed1 | 172 | |
44df2e29 | 173 | git diff-tree -p HEAD $w_tree -- >"$TMP-patch" && |
dda1f2a5 | 174 | test -s "$TMP-patch" || |
b1440ce2 | 175 | die "$(gettext "No changes selected")" |
dda1f2a5 TR |
176 | |
177 | rm -f "$TMP-index" || | |
b1440ce2 | 178 | die "$(gettext "Cannot remove temporary index (can't happen)")" |
dda1f2a5 TR |
179 | |
180 | fi | |
181 | ||
f2c66ed1 | 182 | # create the stash |
9f62e18a JH |
183 | if test -z "$stash_msg" |
184 | then | |
185 | stash_msg=$(printf 'WIP on %s' "$msg") | |
186 | else | |
187 | stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg") | |
188 | fi | |
189 | w_commit=$(printf '%s\n' "$stash_msg" | | |
22f41286 JH |
190 | git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) || |
191 | die "$(gettext "Cannot record working tree state")" | |
bc9e7399 | 192 | } |
f2c66ed1 | 193 | |
bd514cad RR |
194 | store_stash () { |
195 | while test $# != 0 | |
196 | do | |
197 | case "$1" in | |
198 | -m|--message) | |
199 | shift | |
200 | stash_msg="$1" | |
201 | ;; | |
5675473f PH |
202 | -m*) |
203 | stash_msg=${1#-m} | |
204 | ;; | |
205 | --message=*) | |
206 | stash_msg=${1#--message=} | |
207 | ;; | |
bd514cad RR |
208 | -q|--quiet) |
209 | quiet=t | |
210 | ;; | |
211 | *) | |
212 | break | |
213 | ;; | |
214 | esac | |
215 | shift | |
216 | done | |
217 | test $# = 1 || | |
218 | die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")" | |
219 | ||
220 | w_commit="$1" | |
221 | if test -z "$stash_msg" | |
222 | then | |
223 | stash_msg="Created via \"git stash store\"." | |
224 | fi | |
225 | ||
89dea973 | 226 | git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit |
bd514cad | 227 | ret=$? |
268ef4d3 | 228 | test $ret != 0 && test -z "$quiet" && |
bd514cad RR |
229 | die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")" |
230 | return $ret | |
231 | } | |
232 | ||
f5727e26 | 233 | push_stash () { |
7bedebca | 234 | keep_index= |
dda1f2a5 | 235 | patch_mode= |
78751302 | 236 | untracked= |
f5727e26 | 237 | stash_msg= |
fcdd0e92 SB |
238 | while test $# != 0 |
239 | do | |
240 | case "$1" in | |
ea41cfc4 | 241 | -k|--keep-index) |
fcdd0e92 SB |
242 | keep_index=t |
243 | ;; | |
dda1f2a5 | 244 | --no-keep-index) |
3a243f70 | 245 | keep_index=n |
dda1f2a5 TR |
246 | ;; |
247 | -p|--patch) | |
248 | patch_mode=t | |
3a243f70 DM |
249 | # only default to keep if we don't already have an override |
250 | test -z "$keep_index" && keep_index=t | |
fcdd0e92 SB |
251 | ;; |
252 | -q|--quiet) | |
253 | GIT_QUIET=t | |
254 | ;; | |
78751302 DC |
255 | -u|--include-untracked) |
256 | untracked=untracked | |
257 | ;; | |
258 | -a|--all) | |
259 | untracked=all | |
260 | ;; | |
f5727e26 TG |
261 | -m|--message) |
262 | shift | |
263 | test -z ${1+x} && usage | |
264 | stash_msg=$1 | |
265 | ;; | |
5675473f PH |
266 | -m*) |
267 | stash_msg=${1#-m} | |
268 | ;; | |
269 | --message=*) | |
270 | stash_msg=${1#--message=} | |
271 | ;; | |
5ba28313 JK |
272 | --help) |
273 | show_help | |
274 | ;; | |
3c2eb80f MM |
275 | --) |
276 | shift | |
277 | break | |
278 | ;; | |
279 | -*) | |
eed10649 | 280 | option="$1" |
c0c0c825 | 281 | eval_gettextln "error: unknown option for 'stash push': \$option" |
3c2eb80f MM |
282 | usage |
283 | ;; | |
fcdd0e92 SB |
284 | *) |
285 | break | |
286 | ;; | |
287 | esac | |
7bedebca | 288 | shift |
fcdd0e92 | 289 | done |
7bedebca | 290 | |
22fc703e PS |
291 | eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")" |
292 | ||
78751302 DC |
293 | if test -n "$patch_mode" && test -n "$untracked" |
294 | then | |
850251f3 | 295 | die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")" |
78751302 DC |
296 | fi |
297 | ||
df6bba09 TG |
298 | test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1 |
299 | ||
1eff26c0 | 300 | git update-index -q --refresh |
df6bba09 | 301 | if no_changes "$@" |
bc9e7399 | 302 | then |
5a175871 | 303 | say "$(gettext "No local changes to save")" |
bc9e7399 JH |
304 | exit 0 |
305 | fi | |
df6bba09 | 306 | |
89dea973 | 307 | git reflog exists $ref_stash || |
b1440ce2 | 308 | clear_stash || die "$(gettext "Cannot initialize stash")" |
bc9e7399 | 309 | |
df6bba09 | 310 | create_stash -m "$stash_msg" -u "$untracked" -- "$@" |
bd514cad RR |
311 | store_stash -m "$stash_msg" -q $w_commit || |
312 | die "$(gettext "Cannot save the current status")" | |
599e7a0b | 313 | say "$(eval_gettext "Saved working directory and index state \$stash_msg")" |
7bedebca | 314 | |
dda1f2a5 | 315 | if test -z "$patch_mode" |
7bedebca | 316 | then |
bbffd87d | 317 | test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION= |
833622a9 | 318 | if test -n "$untracked" && test $# = 0 |
bbffd87d | 319 | then |
35327868 | 320 | git clean --force --quiet -d $CLEAN_X_OPTION |
bbffd87d NMC |
321 | fi |
322 | ||
df6bba09 TG |
323 | if test $# != 0 |
324 | then | |
833622a9 TG |
325 | test -z "$untracked" && UPDATE_OPTION="-u" || UPDATE_OPTION= |
326 | test "$untracked" = "all" && FORCE_OPTION="--force" || FORCE_OPTION= | |
327 | git add $UPDATE_OPTION $FORCE_OPTION -- "$@" | |
d97e4fa7 JH |
328 | git diff-index -p --cached --binary HEAD -- "$@" | |
329 | git apply --index -R | |
df6bba09 | 330 | else |
1790f4fe | 331 | git reset --hard -q |
df6bba09 | 332 | fi |
dda1f2a5 | 333 | |
268ef4d3 | 334 | if test "$keep_index" = "t" && test -n "$i_tree" |
dda1f2a5 | 335 | then |
e0e7f99e TG |
336 | git read-tree --reset $i_tree |
337 | git ls-files -z --modified -- "$@" | | |
338 | git checkout-index -z --force --stdin | |
dda1f2a5 TR |
339 | fi |
340 | else | |
341 | git apply -R < "$TMP-patch" || | |
b1440ce2 | 342 | die "$(gettext "Cannot remove worktree changes")" |
dda1f2a5 | 343 | |
3a243f70 | 344 | if test "$keep_index" != "t" |
dda1f2a5 | 345 | then |
869fb8f7 | 346 | git reset -q -- "$@" |
dda1f2a5 | 347 | fi |
7bedebca | 348 | fi |
f2c66ed1 NS |
349 | } |
350 | ||
f5727e26 TG |
351 | save_stash () { |
352 | push_options= | |
353 | while test $# != 0 | |
354 | do | |
355 | case "$1" in | |
356 | --) | |
357 | shift | |
358 | break | |
359 | ;; | |
360 | -*) | |
361 | # pass all options through to push_stash | |
362 | push_options="$push_options $1" | |
363 | ;; | |
364 | *) | |
365 | break | |
366 | ;; | |
367 | esac | |
368 | shift | |
369 | done | |
370 | ||
371 | stash_msg="$*" | |
372 | ||
373 | if test -z "$stash_msg" | |
374 | then | |
375 | push_stash $push_options | |
376 | else | |
377 | push_stash $push_options -m "$stash_msg" | |
378 | fi | |
379 | } | |
380 | ||
401de405 | 381 | have_stash () { |
1956dfa8 | 382 | git rev-parse --verify --quiet $ref_stash >/dev/null |
401de405 JK |
383 | } |
384 | ||
f2c66ed1 | 385 | list_stash () { |
401de405 | 386 | have_stash || return 0 |
288c67ca | 387 | git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash -- |
f2c66ed1 NS |
388 | } |
389 | ||
390 | show_stash () { | |
d6cc2df5 | 391 | ALLOW_UNKNOWN_FLAGS=t |
a9bf09e1 | 392 | assert_stash_like "$@" |
14cd4581 | 393 | |
3086c064 NK |
394 | if test -z "$FLAGS" |
395 | then | |
396 | if test "$(git config --bool stash.showStat || echo true)" = "true" | |
397 | then | |
398 | FLAGS=--stat | |
399 | fi | |
400 | ||
401 | if test "$(git config --bool stash.showPatch || echo false)" = "true" | |
402 | then | |
403 | FLAGS=${FLAGS}${FLAGS:+ }-p | |
404 | fi | |
405 | ||
406 | if test -z "$FLAGS" | |
407 | then | |
408 | return 0 | |
409 | fi | |
410 | fi | |
411 | ||
412 | git diff ${FLAGS} $b_commit $w_commit | |
f2c66ed1 NS |
413 | } |
414 | ||
5ba28313 JK |
415 | show_help () { |
416 | exec git help stash | |
417 | exit 1 | |
418 | } | |
419 | ||
ef763129 JS |
420 | # |
421 | # Parses the remaining options looking for flags and | |
422 | # at most one revision defaulting to ${ref_stash}@{0} | |
423 | # if none found. | |
424 | # | |
425 | # Derives related tree and commit objects from the | |
426 | # revision, if one is found. | |
427 | # | |
428 | # stash records the work tree, and is a merge between the | |
429 | # base commit (first parent) and the index tree (second parent). | |
430 | # | |
431 | # REV is set to the symbolic version of the specified stash-like commit | |
432 | # IS_STASH_LIKE is non-blank if ${REV} looks like a stash | |
433 | # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref | |
434 | # s is set to the SHA1 of the stash commit | |
435 | # w_commit is set to the commit containing the working tree | |
436 | # b_commit is set to the base commit | |
437 | # i_commit is set to the commit containing the index tree | |
78751302 | 438 | # u_commit is set to the commit containing the untracked files tree |
ef763129 JS |
439 | # w_tree is set to the working tree |
440 | # b_tree is set to the base tree | |
441 | # i_tree is set to the index tree | |
78751302 | 442 | # u_tree is set to the untracked files tree |
ef763129 JS |
443 | # |
444 | # GIT_QUIET is set to t if -q is specified | |
445 | # INDEX_OPTION is set to --index if --index is specified. | |
d6cc2df5 | 446 | # FLAGS is set to the remaining flags (if allowed) |
ef763129 JS |
447 | # |
448 | # dies if: | |
449 | # * too many revisions specified | |
450 | # * no revision is specified and there is no stash stack | |
451 | # * a revision is specified which cannot be resolve to a SHA1 | |
452 | # * a non-existent stash reference is specified | |
d6cc2df5 | 453 | # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t" |
ef763129 JS |
454 | # |
455 | ||
456 | parse_flags_and_rev() | |
457 | { | |
458 | test "$PARSE_CACHE" = "$*" && return 0 # optimisation | |
459 | PARSE_CACHE="$*" | |
460 | ||
461 | IS_STASH_LIKE= | |
462 | IS_STASH_REF= | |
463 | INDEX_OPTION= | |
464 | s= | |
465 | w_commit= | |
466 | b_commit= | |
467 | i_commit= | |
78751302 | 468 | u_commit= |
ef763129 JS |
469 | w_tree= |
470 | b_tree= | |
471 | i_tree= | |
78751302 | 472 | u_tree= |
ef763129 | 473 | |
ef763129 | 474 | FLAGS= |
a56c8f5a | 475 | REV= |
2bea593b | 476 | for opt |
ef763129 | 477 | do |
2bea593b JS |
478 | case "$opt" in |
479 | -q|--quiet) | |
480 | GIT_QUIET=-t | |
481 | ;; | |
ef763129 JS |
482 | --index) |
483 | INDEX_OPTION=--index | |
484 | ;; | |
5ba28313 JK |
485 | --help) |
486 | show_help | |
487 | ;; | |
2bea593b | 488 | -*) |
d6cc2df5 JK |
489 | test "$ALLOW_UNKNOWN_FLAGS" = t || |
490 | die "$(eval_gettext "unknown option: \$opt")" | |
2bea593b | 491 | FLAGS="${FLAGS}${FLAGS:+ }$opt" |
ef763129 | 492 | ;; |
a56c8f5a AW |
493 | *) |
494 | REV="${REV}${REV:+ }'$opt'" | |
495 | ;; | |
ef763129 | 496 | esac |
ef763129 JS |
497 | done |
498 | ||
2a07e437 | 499 | eval set -- $REV |
ef763129 JS |
500 | |
501 | case $# in | |
502 | 0) | |
e01db917 | 503 | have_stash || die "$(gettext "No stash entries found.")" |
ef763129 JS |
504 | set -- ${ref_stash}@{0} |
505 | ;; | |
506 | 1) | |
507 | : | |
508 | ;; | |
509 | *) | |
33ceddcf | 510 | die "$(eval_gettext "Too many revisions specified: \$REV")" |
ef763129 JS |
511 | ;; |
512 | esac | |
513 | ||
a56c8f5a AW |
514 | case "$1" in |
515 | *[!0-9]*) | |
516 | : | |
517 | ;; | |
518 | *) | |
519 | set -- "${ref_stash}@{$1}" | |
520 | ;; | |
521 | esac | |
522 | ||
1956dfa8 | 523 | REV=$(git rev-parse --symbolic --verify --quiet "$1") || { |
155da748 | 524 | reference="$1" |
ad5fe377 | 525 | die "$(eval_gettext "\$reference is not a valid reference")" |
155da748 | 526 | } |
ef763129 | 527 | |
1956dfa8 | 528 | i_commit=$(git rev-parse --verify --quiet "$REV^2") && |
2a07e437 | 529 | set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) && |
ef763129 JS |
530 | s=$1 && |
531 | w_commit=$1 && | |
532 | b_commit=$2 && | |
533 | w_tree=$3 && | |
534 | b_tree=$4 && | |
535 | i_tree=$5 && | |
536 | IS_STASH_LIKE=t && | |
537 | test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" && | |
538 | IS_STASH_REF=t | |
78751302 | 539 | |
1956dfa8 | 540 | u_commit=$(git rev-parse --verify --quiet "$REV^3") && |
2a07e437 | 541 | u_tree=$(git rev-parse "$REV^3:" 2>/dev/null) |
ef763129 JS |
542 | } |
543 | ||
544 | is_stash_like() | |
545 | { | |
546 | parse_flags_and_rev "$@" | |
547 | test -n "$IS_STASH_LIKE" | |
548 | } | |
549 | ||
550 | assert_stash_like() { | |
777b6f13 ÆAB |
551 | is_stash_like "$@" || { |
552 | args="$*" | |
553 | die "$(eval_gettext "'\$args' is not a stash-like commit")" | |
554 | } | |
ef763129 JS |
555 | } |
556 | ||
557 | is_stash_ref() { | |
558 | is_stash_like "$@" && test -n "$IS_STASH_REF" | |
559 | } | |
560 | ||
561 | assert_stash_ref() { | |
777b6f13 ÆAB |
562 | is_stash_ref "$@" || { |
563 | args="$*" | |
564 | die "$(eval_gettext "'\$args' is not a stash reference")" | |
565 | } | |
ef763129 JS |
566 | } |
567 | ||
f2c66ed1 | 568 | apply_stash () { |
fcdd0e92 | 569 | |
064ed100 | 570 | assert_stash_like "$@" |
f2c66ed1 | 571 | |
b1440ce2 | 572 | git update-index -q --refresh || die "$(gettext "unable to refresh index")" |
5fd448f1 OA |
573 | |
574 | # current index state | |
575 | c_tree=$(git write-tree) || | |
b1440ce2 | 576 | die "$(gettext "Cannot apply a stash in the middle of a merge")" |
5fd448f1 | 577 | |
cbeaccc3 | 578 | unstashed_index_tree= |
064ed100 | 579 | if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" && |
7bedebca | 580 | test "$c_tree" != "$i_tree" |
cbeaccc3 | 581 | then |
89d750bf | 582 | git diff-tree --binary $s^2^..$s^2 | git apply --cached |
150937c4 | 583 | test $? -ne 0 && |
b1440ce2 | 584 | die "$(gettext "Conflicts in index. Try without --index.")" |
52070790 | 585 | unstashed_index_tree=$(git write-tree) || |
b1440ce2 | 586 | die "$(gettext "Could not save index tree")" |
150937c4 | 587 | git reset |
cbeaccc3 | 588 | fi |
150937c4 | 589 | |
78751302 DC |
590 | if test -n "$u_tree" |
591 | then | |
974ce807 | 592 | GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" && |
78751302 DC |
593 | GIT_INDEX_FILE="$TMPindex" git checkout-index --all && |
594 | rm -f "$TMPindex" || | |
e01db917 | 595 | die "$(gettext "Could not restore untracked files from stash entry")" |
78751302 DC |
596 | fi |
597 | ||
f2c66ed1 NS |
598 | eval " |
599 | GITHEAD_$w_tree='Stashed changes' && | |
600 | GITHEAD_$c_tree='Updated upstream' && | |
601 | GITHEAD_$b_tree='Version stash was based on' && | |
602 | export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree | |
603 | " | |
604 | ||
fcdd0e92 SB |
605 | if test -n "$GIT_QUIET" |
606 | then | |
69ae92bd | 607 | GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY |
fcdd0e92 | 608 | fi |
52070790 | 609 | if git merge-recursive $b_tree -- $c_tree $w_tree |
f2c66ed1 NS |
610 | then |
611 | # No conflict | |
cbeaccc3 JH |
612 | if test -n "$unstashed_index_tree" |
613 | then | |
614 | git read-tree "$unstashed_index_tree" | |
83b3df7d JH |
615 | else |
616 | a="$TMP-added" && | |
89d750bf | 617 | git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" && |
83b3df7d JH |
618 | git read-tree --reset $c_tree && |
619 | git update-index --add --stdin <"$a" || | |
b1440ce2 | 620 | die "$(gettext "Cannot unstage modified files")" |
83b3df7d | 621 | rm -f "$a" |
cbeaccc3 | 622 | fi |
fcdd0e92 SB |
623 | squelch= |
624 | if test -n "$GIT_QUIET" | |
625 | then | |
626 | squelch='>/dev/null 2>&1' | |
627 | fi | |
26b59b48 | 628 | (cd "$START_DIR" && eval "git status $squelch") || : |
f2c66ed1 NS |
629 | else |
630 | # Merge conflict; keep the exit status from merge-recursive | |
150937c4 | 631 | status=$? |
743bf6d8 | 632 | git rerere |
064ed100 | 633 | if test -n "$INDEX_OPTION" |
cbeaccc3 | 634 | then |
6fdd50e9 | 635 | gettextln "Index was not unstashed." >&2 |
cbeaccc3 | 636 | fi |
150937c4 | 637 | exit $status |
f2c66ed1 NS |
638 | fi |
639 | } | |
640 | ||
f276872d JS |
641 | pop_stash() { |
642 | assert_stash_ref "$@" | |
643 | ||
2d4c9933 JH |
644 | if apply_stash "$@" |
645 | then | |
646 | drop_stash "$@" | |
647 | else | |
648 | status=$? | |
e01db917 | 649 | say "$(gettext "The stash entry is kept in case you need it again.")" |
2d4c9933 JH |
650 | exit $status |
651 | fi | |
f276872d JS |
652 | } |
653 | ||
e25d5f9c | 654 | drop_stash () { |
92e39e44 | 655 | assert_stash_ref "$@" |
e25d5f9c | 656 | |
92e39e44 | 657 | git reflog delete --updateref --rewrite "${REV}" && |
d4ca6c8b ÆAB |
658 | say "$(eval_gettext "Dropped \${REV} (\$s)")" || |
659 | die "$(eval_gettext "\${REV}: Could not drop stash entry")" | |
e25d5f9c BC |
660 | |
661 | # clear_stash if we just dropped the last stash entry | |
1956dfa8 DA |
662 | git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null || |
663 | clear_stash | |
e25d5f9c BC |
664 | } |
665 | ||
656b5034 | 666 | apply_to_branch () { |
b1440ce2 | 667 | test -n "$1" || die "$(gettext "No branch name specified")" |
656b5034 | 668 | branch=$1 |
fb433dc9 | 669 | shift 1 |
656b5034 | 670 | |
fb433dc9 JS |
671 | set -- --index "$@" |
672 | assert_stash_like "$@" | |
673 | ||
674 | git checkout -b $branch $REV^ && | |
57693d03 JS |
675 | apply_stash "$@" && { |
676 | test -z "$IS_STASH_REF" || drop_stash "$@" | |
677 | } | |
656b5034 AMS |
678 | } |
679 | ||
9e140909 TG |
680 | test "$1" = "-p" && set "push" "$@" |
681 | ||
ef763129 | 682 | PARSE_CACHE='--not-parsed' |
1ada5020 | 683 | # The default command is "push" if nothing but options are given |
3c2eb80f MM |
684 | seen_non_option= |
685 | for opt | |
686 | do | |
687 | case "$opt" in | |
9e140909 | 688 | --) break ;; |
3c2eb80f MM |
689 | -*) ;; |
690 | *) seen_non_option=t; break ;; | |
691 | esac | |
692 | done | |
693 | ||
1ada5020 | 694 | test -n "$seen_non_option" || set "push" "$@" |
3c2eb80f | 695 | |
f2c66ed1 NS |
696 | # Main command set |
697 | case "$1" in | |
fcb10a96 JH |
698 | list) |
699 | shift | |
f2c66ed1 NS |
700 | list_stash "$@" |
701 | ;; | |
702 | show) | |
703 | shift | |
704 | show_stash "$@" | |
705 | ;; | |
683befa1 KL |
706 | save) |
707 | shift | |
47629dcf | 708 | save_stash "$@" |
683befa1 | 709 | ;; |
f5727e26 TG |
710 | push) |
711 | shift | |
712 | push_stash "$@" | |
713 | ;; | |
f2c66ed1 NS |
714 | apply) |
715 | shift | |
716 | apply_stash "$@" | |
717 | ;; | |
718 | clear) | |
3023dc69 JH |
719 | shift |
720 | clear_stash "$@" | |
f2c66ed1 | 721 | ;; |
bc9e7399 | 722 | create) |
0719f300 | 723 | shift |
9ca6326d | 724 | create_stash -m "$*" && echo "$w_commit" |
bc9e7399 | 725 | ;; |
bd514cad RR |
726 | store) |
727 | shift | |
728 | store_stash "$@" | |
729 | ;; | |
e25d5f9c BC |
730 | drop) |
731 | shift | |
732 | drop_stash "$@" | |
733 | ;; | |
bd56ff54 BC |
734 | pop) |
735 | shift | |
f276872d | 736 | pop_stash "$@" |
bd56ff54 | 737 | ;; |
656b5034 AMS |
738 | branch) |
739 | shift | |
740 | apply_to_branch "$@" | |
741 | ;; | |
f2c66ed1 | 742 | *) |
3c2eb80f MM |
743 | case $# in |
744 | 0) | |
1ada5020 | 745 | push_stash && |
5a175871 | 746 | say "$(gettext "(To restore them type \"git stash apply\")")" |
ea41cfc4 JS |
747 | ;; |
748 | *) | |
683befa1 | 749 | usage |
ea41cfc4 | 750 | esac |
9f62e18a | 751 | ;; |
f2c66ed1 | 752 | esac |